#!- 
#!-   CGI Templates for use with WebSite or Microsoft IIS for Windows NT
#!- 
#!-   09/28/96
#!-   Dave Berton
#!-   CIS 102644,3557
#!- 
#!-   Ver 1.1       1/30/97
#!-       Modified to support both WebSite and IIS for Windows NT
#!- 
#!- 
#!-   Revised template set, modified by Tom H. (tomh@clariononline.com)
#!-   * Corrected bug for empty value
#!-   * Fixed OVERLAPPED problem (not supported under Win9x, only NT)
#!-   * Fixed incorrect handling of large forms (not fetching all data)
#!-   * Added automatic URL decoding of input ('FixURLEncoding' method) 
#!-   * Added method for easy creation of messages (see 'WebMsg' method)
#!-   * Assorted other tweaks and changes
#!- 
#!-   -- WebMsg: ID      - A string to identify the user, program location, whatever
#!-              Action  - String containing what the user requested/wanted to do
#!-              Response- String explaining what the result was
#!-              Status  - overall status, forms line: 'Request ' & status
#!-                        Example, passing 'Completed!' = 'Request Completed!'
#!-              Backlink- If blank, generates 'Use Back button', otherwise must be
#!-                        must be a valid hyperlink dest, e.g., '/default.htm'
#!-   -- Example Usage
#!-      - Your program processed a form ok, so take them back to a menu...
#!-      WebMsg('','Add new Record','Record was added','Completed!','/FormMenu.htm')
#!-   
#!-      - User didn't enter required field, tell them to use 'Back' button to fix it
#!-      WebMsg('','Add new Record','Missing Required field','Failed!','')
#!-
#TEMPLATE(CGI, 'Standard CGI Template')
#INCLUDE('IISCGI.TPW')
#EXTENSION(CGI,'CGI Global Extensions'), APPLICATION
#SHEET
 #TAB('General')
        #BOXED('CGI Processing')
            #DISPLAY(' ')
            #DISPLAY('The Global CGI Object will output an HTML document,')
            #DISPLAY('leaving room between the <<BODY> ... <</BODY> tags')
            #DISPLAY('for your output.  ')
            #DISPLAY('Select ''CGIProcedure'' as the application''s first')
            #DISPLAY('procedure, and insert your processing code there.')
            #DISPLAY('')
        #ENDBOXED
        #DISPLAY(' ')
        #PROMPT('CGI Class Name:', @s255), %CGIClassName, REQ
        #DISPLAY('(Enables calls to object from other procedures,')
        #DISPLAY(' i.e., MyClassName.HTMLOut(''Some Text<<p>'') )')
        #DISPLAY('')
      #ENDTAB
      #TAB('HTML Setup')
        #DISPLAY(' ')
        #BOXED('HTML Generation')
            #PROMPT('Generate all HTML', CHECK), %HTMLGenerateAll, DEFAULT(1)
            #ENABLE(%HTMLGenerateAll=1)
                #PROMPT('HTML Title:', @s255), %HTMLTitle
                #PROMPT('Inside <<Body> Tag:', @s255), %HTMLBody
                #PROMPT('HTML mailto text:', @s255), %HTMLMailto
                #PROMPT('HTML mailto address:', @s255), %HTMLMailtoAddress
                #PROMPT('HTML Copyright Notice:', @s255), %HTMLCopy
                #PROMPT('HTML Last Updated:', @s255), %HTMLLastUpdated
                #PROMPT('Generate CR/LF after each generated line',CHECK),%HTMLLineFeed
            #ENDENABLE
        #ENDBOXED
    #ENDTAB
    #TAB('Tables')
        #BOXED('Default Table Generation')
                #PROMPT('Use Nscape Tables', CHECK), %HTMLNscapeTables, DEFAULT(1)
                #ENABLE(%HTMLNscapeTables = 1)
                    #PROMPT('Table BORDER width:', SPIN(@n2,0,10)), %HTMLBorder, DEFAULT(1)
                    #PROMPT('CENTER Tables', CHECK), %HTMLCenterTables, DEFAULT(1), AT(10,,,)
                    #PROMPT('WIDTH Percentage', SPIN(@n3,10,100,5)), %HTMLWidthPercentage, DEFAULT(100)
                #ENDENABLE
        #ENDBOXED
     #ENDTAB
#ENDSHEET
#AT(%BeforeGlobalIncludes)
  INCLUDE('winequ.clw')               !- Windows API equates
#ENDAT
#AT(%GlobalMap)
    !- CGI API calls
  MODULE('win32.lib')
    GetStdHandle(DWORD),HANDLE,PASCAL
    ReadFile(HANDLE,*CSTRING,DWORD,*DWORD,<*OVERLAPPED>),BOOL,PASCAL,RAW
    WriteFile(HANDLE,*CSTRING,DWORD,*DWORD,<*OVERLAPPED>),BOOL,PASCAL,RAW
    GetEnvironmentVar(*LPCSTR,*LPSTR,DWORD),DWORD,PASCAL,RAW,NAME('GetEnvironmentVariableA')
    SetFilePointer(HANDLE,LONG,LONG,DWORD),DWORD,PASCAL
    SetEndOfFile(HANDLE),BOOL,PASCAL
  END
#ENDAT
#AT(%GlobalData)
                                !- CGI Global Template Data
OutFileName CSTRING(255)
CGIINIFileName     CSTRING(2000)
WorkFileName    STRING(255)

Tuple       QUEUE, PRE(TQ)      !-  Used for Accept: and "extra" headers
Key         STRING(255)         !-  and for holding POST form key=value pairs
Value       CSTRING(1024)
offset      LONG                !-  Byte offset into Content File of value [FORM HUGE]
length      LONG                !-  Length of value, bytes  [FORM HUGE]
Type        STRING(15)          !-  [ACCEPT], [EXTRA HEADERS],  [FORM LITERAL] or [FORM HUGE]
    .

FileTuple   QUEUE, PRE(FTQ)     !-  Used for form-based file uploads
key         STRING(255)         !-  Form field name
file        STRING(255)         !-  Local tempfile containing uploaded file
length      LONG                !-  Length in bytes of uploaded file
type        STRING(255)         !-  Content type of uploaded file
encoding    STRING(255)         !-  Content-transfer encoding of uploaded file
name        STRING(255)         !-  Original name of uploaded file
  .

                                !- Object Equates
_Center      EQUATE(1)
_Default     EQUATE(0)
_Left        EQUATE(2)
_Right       EQUATE(3)

FILE_BEGIN           EQUATE(0)
STD_INPUT_HANDLE     EQUATE(-10)
STD_OUTPUT_HANDLE    EQUATE(-11)

!- For WriteFile() API
OVERLAPPED      GROUP,TYPE
Internal         DWORD
InternalHigh     DWORD
Offset           DWORD
OffsetHigh       DWORD
hEvent           HANDLE
                END

VarLen                  EQUATE(129)

!- Writefile vars
lBytesWritten           ULONG
OVERLAPPED_      LIKE(OVERLAPPED)

                                !- CGI Object
ClassCGI                        CLASS, TYPE
ErrorString                     STRING(255)
hStdIn                          LONG
hStdOut                         LONG
CGI_RequestMethod               CSTRING(50)
CGI_ContentLength               CSTRING(50)
CGI_QueryString                 CSTRING(1000)
CGI_FormData                    CSTRING(64000)
TableCenter                     BYTE
TableBorder                     BYTE
TableRowAlign                   BYTE
TableWidth                      BYTE
_DefTableCenter                 BYTE
_DefTableBorder                 BYTE
_DefTableRowAlign               BYTE
_DefTableWidth                  BYTE
GetAllCGI                       PROCEDURE
GetValue                        FUNCTION(STRING MyValue), STRING
CGIInit                         PROCEDURE, NAME('CGIInit')
HTMLOut                         PROCEDURE(STRING)
TableSet                        PROCEDURE(BYTE Center, BYTE Border, BYTE RowAlign, BYTE Width)
TableHeader                     PROCEDURE(STRING MyHeader)
TableItem                       PROCEDURE(STRING MyItems)
TableFooter                     PROCEDURE
ErrorOut                        PROCEDURE
FixURLEncoding                  PROCEDURE(*CSTRING)
WebMsg                          PROCEDURE(STRING,STRING,STRING,STRING,STRING)
HeaderOut                       PROCEDURE, VIRTUAL
FooterOut                       PROCEDURE, VIRTUAL
CGI                             PROCEDURE, VIRTUAL
                                END!- Class

!- User CGI Class
#FOR(%Module), WHERE(%ModuleProcedure <> %Program)
    #FOR(%ModuleProcedure), WHERE(%ModuleProcedure = %FirstProcedure)
%CGIClassName                   CLASS(ClassCGI), MODULE('%Module')
    #ENDFOR
#ENDFOR
CGI                             PROCEDURE, VIRTUAL
HeaderOut                       PROCEDURE, VIRTUAL
FooterOut                       PROCEDURE, VIRTUAL
                                END!- Class

                                !- END CGI Global Template Data
#ENDAT
#AT(%ProgramProcedures)
#INSERT(%CGIClassMethods)
#ENDAT
#!-----------------------------------------------------------------------------------------
#PROCEDURE(CGIProcedure, 'Main CGI Procedure')
#PROTOTYPE('')
#DISPLAY(' ')
#DISPLAY(' ')
#BUTTON('ClassCGI Object Method Reference'), AT(,,150,)
    #SHEET
        #TAB('General')
            #BOXED('General Methods')
                #DISPLAY(' ')
                #DISPLAY('SELF.GetAllCGI')
                #DISPLAY('    - Initializes all Values from current CGI session.')
                #DISPLAY(' ')
                #DISPLAY('SELF.GetValue(MyValue)')
                #DISPLAY('    - Returns a Value from CGI session.')
                #DISPLAY('      Use SELF.GetAllCGI first.')
                #DISPLAY(' ')
                #DISPLAY('SELF.HTMLOut(MyOut)')
                #DISPLAY('    - Prints out a single line of HTML')
                #DISPLAY(' ')
            #ENDBOXED
         #ENDTAB
         #TAB('Tables')
            #BOXED('Table Methods')
                #DISPLAY(' ')
                #DISPLAY('SELF.TableHeader(MyHeader)')
                #DISPLAY('    - Begins a <<TABLE...> structure.')
                #DISPLAY('      MyHeader is of the format:')
                #DISPLAY('          ''PONum|Price|Adress|...'' ')
                #DISPLAY(' ')
                #DISPLAY('SELF.TableItem(MyItem)')
                #DISPLAY('    - A single row of a table.')
                #DISPLAY('      MyItem is of the format:')
                #DISPLAY('          ''123|$12.95|1 Main St|...'' ')
                #DISPLAY(' ')
                #DISPLAY('SELF.TableFooter')
                #DISPLAY('    - The end of the <<TABLE...> structure.')
                #DISPLAY('      This method MUST be called for the')
                #DISPLAY('      table to appear.')
                #DISPLAY('  ')
                #DISPLAY('SELF.TableSet(Center, Border, RowAlign, Width)')
                #DISPLAY('    - Resets the table properties.')
                #DISPLAY(' ')
            #ENDBOXED
        #ENDTAB
        #TAB('Internal')
            #BOXED('Internal Methods')
                #DISPLAY(' ')
                #DISPLAY('SELF.CGIInit')
                #DISPLAY('    - Constructor method for the')
                #DISPLAY('      object.  When finished, calls')
                #DISPLAY('      the user defined method SELF.CGI')
                #DISPLAY(' ')
            #ENDBOXED
        #ENDTAB
    #ENDSHEET
#ENDBUTTON
#DISPLAY(' ')
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(Clarion))
#ENDAT
                                !- Module Data used by ClassCGI Object
#FOR(%LocalData)
%LocalData %LocalDataStatement
#ENDFOR
#EMBED(%CGIDataSection,'CGI Data Section'),DATA
    #EMBED(%CGIBeforeOpenFiles, 'CGI Before Open Files')
#INSERT(%FileControlInitialize(Clarion))
%Procedure %ProcedureType       !- Declare Procedure
    CODE
    #EMBED(%CGIHandCodeBeforeInit, 'Before CGI Initialization')
    %CGIClassName.CGIInit
    #EMBED(%CGIHandCodeAfterInit, 'After CGI Processing')

%CGIClassName.CGI PROCEDURE
    CODE
    #FOR(%ProcFilesUsed)
    #INSERT(%FileControlOpenFile(Clarion),%ProcFilesUsed)
    #ENDFOR
    !- Embedded Source Begins Here
    !---------------------------
    #EMBED(%CGIHandCode,'CGI Processing')
#EMBED(%CGIRoutines, 'Procedure Routines')
%CGIClassName.HeaderOut  PROCEDURE             !-  Declare Header Procedure
    CODE
    !- Header Code
    !---------------
    #EMBED(%HTMLHeaderCode, 'Header Code')
%CGIClassName.FooterOut  PROCEDURE             !-  Declare Footer Procedure
    CODE
    !- Footer Code
    !---------------
    #EMBED(%HTMLFooterCode, 'Footer Code')
#!-----------------------------------------------------------------------------------------









